#include <stdio.h>
#include <stdlib.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>

extern double Mygsl_rhy_dists(int distribnumber, int counter, const gsl_rng * r);

float *rhy1Dinput_gsl(float *rhy1Dreturnarray)
{
    char c;
    //mem ptrs for ran gen
    const gsl_rng_type * T;
    gsl_rng * r;

    int x = 1;
    int index = 1;
    int rand(void);
    //float *rhy1Darray, value;
    int values, f, h, nn, nums;
    int l = 1;
    float *s, *pp;
    int rhydist;
    int distcounter;

    double u; //value returned from Mygsl_rhy_dists

    struct timeval  t1;

first:
    distcounter = 1;  //sets or resets counter

    /* create a generator chosen by the
           environment variable GSL_RNG_TYPE.
           In this case using 'taus' algo */
    gsl_rng_env_setup();
    T = gsl_rng_taus; //use taus algo as ran gen
    r = gsl_rng_alloc (T);  //alloc mem, see free below

    s=(float*)calloc(1000,sizeof(float));/*pointer 's' is allocated 1000
				  floats and treated like an array */
    pp=(float*)calloc(1000,sizeof(float));

    printf("\n");
    printf("Enter the number of values to input: ");
    scanf("%d",&nums);
    h = nums + 1; //highest equals the number of values + 1

    printf ("\n");
    x=1;
    do
    {
        printf("Enter value #%d, (Ex. 0.25): ", x);
        scanf("%f",&s[x]);
        x++;
    }
    while (x < nums+1);
    printf("\n\n");

    printf("How many values to be returned: ");
    scanf("%d",&values);

//***************************************
//*****  SELECT RANDOM DISTRIBUTION *****
//***************************************

    printf("\n");
    printf("\t\t\t***** RHYTHM DISTRIBUTIONS *****");
    printf("\n1 = gaussian, 2 = gaussian_tail, 3 = exponential, 4 = laplace\
            \n5 = exppow, 6 = cauchy, 7 = rayleigh, 8 = rayleigh_tail\
            \n9 = landau, 10 = levy, 11 = levy_skew, 12 = gamma\
            \n13 = flat, 14 = lognormal, 15 = chisq, 16 = fdist\
            \n17 = tdist, 18 = beta, 19 = logistic, 20 = pareto\
            \n21 = Weibell, 22 = gumbel1, 23 = gumbel2, 24 = poisson\
            \n25 = binomial, 26 = negative_binomial, 27 = pascal\
            \n28 = geometric, 29 = hypergeometric, 30 = logarithmic\
            \n\nEnter a distribution for rhythm:  ");
    scanf("%d",&rhydist);

//++++++++++++++++++++
//
//  randomize values (arcsine)
//
//++++++++++++++++++++
    pp[0] = 0.0;
    for (x=1; x<=values; x++)
    {
next:
        gettimeofday(&t1, NULL);
        gsl_rng_default_seed = t1.tv_usec * t1.tv_sec; //use time as gen seed

        //****GSL. Get a random distribution****
        u = Mygsl_rhy_dists(rhydist, distcounter, r);
        f=(int)(u*h-1)+1; //limits between ranges

        if (distcounter > 3000)
        {
            free(s);
            free(pp);
            gsl_rng_free (r);
            printf("\n The distribution is not generating numbers\
                \n within the ranges specified.  Try entering\
                \n different input values for the distribution. \n");
            goto first;
        }

        if(h==1)   //avoids rare case where highest = 1
        {
            if(f<l || f>h)
            {
                distcounter++;
                goto next;
            }
        }
        else
        {
            if(f<l || f>h-1)  /*avoid out of bounds nums */
            {
                distcounter++;
                goto next;
            }
        }
        pp[x]= s[f];
        distcounter++;
    } //end for loop
    pp[values+1] = 0.0; //this is for printf from main.c
//+++++++++++++++++++++

    printf("\nHere's the spin...");
    printf("\n");
    for(x=1; x<=values; x++)
    {
        printf(" %2.4f ", pp[x]);
    }
    printf("\n\n");
//++++++++++++++++++++
//
//  Switch to try another spin
//
//++++++++++++++++++++
    printf("try again? (y)es, (n)o: ");
    while (getchar()!='\n');
    scanf("%c", &c);
    switch(c)
    {
    case 'y':
        free(s);
        free(pp);
        gsl_rng_free (r);
        goto first;
        break;
    case 'n':
        printf("\nbye");
        break;
    default:
        break;
    }//ends switch
    printf("\n");

    free(s);
    gsl_rng_free (r);
    return pp;
    free(pp);
}

/*
.25, .5, 1.0, 1.5  1-dim
((.25, .75), (75, .25), (.5, .5))  2-dim (1 quarter)
((1.0, 0.5), (1.75, 0.25))  2-dim (half note)
*/
